import controlP5.*;
ControlP5 controlP5;
ControlWindow controlWindow;
ControlWindowCanvas cc;

color[] rainbow;

bkNode root;
String line;
HashMap<String,ArrayList<String>> barcodeHash;
HashMap<String,ArrayList<String>> ckoutTimeHash;
HashMap<String,bkNode> nodeHash;
ArrayList<float[]> nodeCoord;
float[][] items;
int nodecount = 0;
int c = 0;
bkNode rolloverItem;
Queue<bkNode> queueNodes;
float px;
float py;
PFont tagfont;
PFont deweyFont;
int stackcount = 0;
LinkedList<bkNode> queueUpdateNodes;// = new LinkedList<bkNode>();
void setup(){
  size(1024,768);
  smooth();
  frameRate(30);
  tagfont = createFont("ArialMT",12);
  deweyFont = createFont("SansSerif.bold",14);
  rectMode(CENTER);
  ellipseMode(CENTER);
  controlP5 = new ControlP5(this);
  controlP5.setControlFont(createFont("SansSerif.bold", 10));
  controlP5.setColorForeground(color(208,219,245));
  controlP5.setColorBackground(color(173,194,245));
  ControlGroup lb = controlP5.addGroup("Book name",10,20);
  lb.setBarHeight(12);
  lb.setWidth(80);
  lb.addCanvas(new infoCanvas()); 
  ControlGroup ld = controlP5.addGroup("deweyCategory",100,20);
  ld.setBarHeight(12);
  ld.setWidth(110);
  ld.addCanvas(new deweyCanvas());
  ld.close();
  controlP5.addButton("clearAll",0,220,7,70,12);
   
  buildBkTree();
  loadRainbowColor();
  //queueUpdateNodes = new LinkedList<bkNode>();
  //queueUpdateNodes.add(root);
}
void draw(){
  background(0);
  rolloverItem = null;
  LinkedList<bkNode> queueNodes = new LinkedList<bkNode>();
  queueNodes.add(root);
  while(!queueNodes.isEmpty()){
    bkNode currentNode = queueNodes.poll();
    if(!currentNode.drawed){
      currentNode.drawNode();
    }
    if(currentNode.expanded){
      for(int i = 0;i < currentNode.ccount;i++){
        //currentNode.children[i].update();
        //if(!currentNode.children[i].drawed){          
          queueNodes.add(currentNode.children[i]);
        //}
      }
    }
  }
  /*if(!queueUpdateNodes.isEmpty()){
    bkNode currentNode = queueUpdateNodes.poll();
    if(!currentNode.updated){
      currentNode.update();
    }
    for(int i = 0;i < currentNode.ccount;i++){
      if(!currentNode.children[i].updated){          
        queueUpdateNodes.add(currentNode.children[i]);
      }
    }
  }*/
  if(rolloverItem != null){
    rolloverItem.drawInfo();
    if(!rolloverItem.expanded || rolloverItem.ccount == 0){
      queueNodes.add(root);
      while(!queueNodes.isEmpty()){
        bkNode currentNode = queueNodes.poll();
        if(currentNode.drawed){
          currentNode.compare();
        }
        if(currentNode.expanded){
          for(int i = 0;i < currentNode.ccount;i++){
            queueNodes.add(currentNode.children[i]);
          }
        }
      }
    }
  }
  root.clearDrawHistory();
}
void mouseMoved(){
  px = mouseX;
  py = mouseY;
}
void mouseClicked(){
  LinkedList<bkNode> queueNodes = new LinkedList<bkNode>();
  queueNodes.add(root);
  while(!queueNodes.isEmpty()){
    bkNode currentNode = queueNodes.poll();
    if(currentNode.mousePressed()){
      break;
    }
    if(currentNode.expanded){
      for(int i = 0;i < currentNode.ccount;i++){
        //if(!currentNode.children[i].tested){
          queueNodes.add(currentNode.children[i]);
        //}
      }
    }
  }
  //root.mousePressed();
  //println("mousePressed");
}
void mouseDragged(){
  LinkedList<bkNode> queueNodes = new LinkedList<bkNode>();
  queueNodes.add(root);
  while(!queueNodes.isEmpty()){
    bkNode currentNode = queueNodes.poll();
    if(currentNode.mouseDragged()){
      break;
    }
    if(currentNode.expanded){
      for(int i = 0;i < currentNode.ccount;i++){
        //if(!currentNode.children[i].tested){
          queueNodes.add(currentNode.children[i]);
        //}
      }
    }
  }
}

public void clearAll(int theValue) {
  LinkedList<bkNode> queueNodes = new LinkedList<bkNode>();
  queueNodes.add(root);
  while(!queueNodes.isEmpty()){
    bkNode currentNode = queueNodes.poll();
    currentNode.updated = false;
    if(currentNode.expanded){
      for(int i = 0;i < currentNode.ccount;i++){
        queueNodes.add(currentNode.children[i]);
      }
    }
    currentNode.expanded = false;
  }
}
