class bkNode implements Comparable<bkNode>{
  bkNode pnode;
  String pname;
  int count;
  int ccount;
  int index = 0;
  int no;
  String date;
  float x,y;

  int level;
  boolean updated = false;
  boolean drawed = false;
  boolean expanded = false;
  boolean visible = true;
  
  
  String[] items;
  String[] barcodes;
  bkNode[] children;
  public bkNode(){
    pnode = null;pname = null;level = 0;
  }
  public bkNode(bkNode parent,String name){
    pnode = parent;
    pname = name;
    level = parent.level + 1;
  }
  void setDate(String date){
    this.date = date;
  }
  int compareTo(bkNode b){
    Integer dewey1 = Integer.parseInt(this.pname.substring(0,3));
    Integer dewey2 = Integer.parseInt(b.pname.substring(0,3));
    return dewey1.compareTo(dewey2);
  }
  void update(){
    List<String> tmpArray = ckoutTimeHash.get(date);
    count = tmpArray.size();
    items = new String[count];
    barcodes = new String[count];
    if(pnode != null){
      float len = 150 / (level * 0.4 + 1);
      x = pnode.x + len * sin(2 * no * PI / pnode.index);
      y = pnode.y + len * cos(2 * no * PI / pnode.index);
    }
    List<bkNode> childArray = new ArrayList<bkNode>();

    for(int i = 0; i < count;i++){
      barcodes[i] = tmpArray.get(i);
      items[i] = (barcodeHash.get(barcodes[i])).get(0);
      int k = 1;
      while(k < barcodeHash.get(barcodes[i]).size()){
        if((barcodeHash.get(barcodes[i]).get(k)).compareTo(date) <= 0){
          k++;
        }else break;
      }
      if(k < barcodeHash.get(barcodes[i]).size()){
        String tmpdate = (barcodeHash.get(barcodes[i])).get(k);
        if(!nodeHash.containsKey(tmpdate)){
          bkNode cnode = new bkNode(this,items[i]);
          cnode.setDate(tmpdate);
          childArray.add(cnode);      
          nodeHash.put(tmpdate,cnode);
          index++;
        }else{
          boolean flag = false;
          bkNode tmpnode = nodeHash.get(tmpdate);
          for(int j = 0;j < childArray.size();j++){
            if(tmpnode == childArray.get(j)){
              flag = true;
              break;
            }
          }
          if(!flag){
            childArray.add(tmpnode);
          }
        }
      }
    }
    Collections.sort(childArray);
    ccount = childArray.size();
    children = new bkNode[ccount];  
    childArray.toArray(children);
    int tmp = 0;
    for(int i = 0;i < ccount; i ++){
      if(children[i].pnode == this){
        children[i].no = tmp++;
      }
    }
    updated = true;
  }
  void setCoord(float x, float y){
    this.x = x;
    this.y = y;
  }
  void drawNode(){   
    drawed = true;
    int rad = count/2 + 2;
    if(mouseInside()){ 
      rolloverItem = this;         
      stroke(220,210,50);
      strokeWeight(2);
      fill(204,180);
      if(expanded){
        for(int i = 0;i < ccount;i++){
          int dewey = Integer.parseInt(children[i].pname.substring(0,3));
          stroke(rainbow[dewey],200);
          strokeWeight(3);
          line(x,y,children[i].x,children[i].y);
        }
      }
      stroke(204,180);
      strokeWeight(3);
      if(pnode!=null){
        
        line(x,y,pnode.x,pnode.y);
      }
      ellipse(x,y,rad,rad);
    }else{
      if(expanded){
        for(int i = 0;i < ccount;i++){
          int dewey = Integer.parseInt(children[i].pname.substring(0,3));
          stroke(rainbow[dewey],150);
          strokeWeight(3);
          line(x,y,children[i].x,children[i].y);
        }
      }
      stroke(204);
      strokeWeight(1);
      fill(204,180);
      ellipse(x,y,rad,rad);    
    }
  }
  boolean mouseInside() {
    return (dist(mouseX, mouseY, x, y) <= count/2+2);   
  }  
  void drawInfo(){
    stroke(128);
    strokeWeight(2);
    fill(180);
    textFont(tagfont);
    if(!expanded || ccount == 0){
      String tag = date + "\n" + pname;
      fill(204);
      rect(mouseX,mouseY - 18,textWidth(tag) + 16,36);    
      fill(0);
      text(tag,mouseX - textWidth(tag) / 2 - 8,mouseY-24);
    }
  }
  void compare(){
    if(this != rolloverItem){
      for(int i = 0;i < count;i++)
        if(items[i].equals(rolloverItem.pname)){
          String tag = date;// + "\n" + items[i];
          fill(204);
          rect(x,y - 9,textWidth(tag) + 16,18);    
          fill(0);
          text(tag,x - textWidth(tag)/2 - 8,y - 3);
        }
    }
  }
  boolean mousePressed(){
    if(!expanded){
      if(mouseInside() && mouseButton == LEFT){
        expanded = true;
        for(int i = 0;i < ccount;i++){
          if(!children[i].updated){
            children[i].update();
          }
        }
        return true;
      }   
    }else if(mouseInside() && mouseButton == RIGHT){
      expanded = false;
      for(int i = 0;i < ccount;i++){
        children[i].updated = false;
      }
      return true;
    }
    return false;
  }
  void clearDrawHistory(){
    drawed = false;
    for(int i = 0; i < ccount;i++){
      if(children[i].drawed){
        children[i].clearDrawHistory();
      }
    }
  }
  boolean mouseDragged(){
    if(mouseInside()){
      x = mouseX;
      y = mouseY;
      /*for(int i = 0;i < ccount;i++){
        children[i].update();
      }*/
      return true;
    }
    return false;
  }
}
